<template>
  <div class="feature-panel" id="settings-panel">
    <button class="feature-link back-btn" id="settings-back-button" tabindex="0" aria-label="Back"
      v-on:click="$router.push('/')">
      <img class="back-icon" src="@/assets/back-arrow.svg" alt="Back" />{{
        $t("Settings.back")
      }}
    </button>
    <div v-for="(settingGroup, index) in Object.entries(settings)" :key="index">
      <div v-if="(settingGroup as any)[1].label != 'hidden'">
        <button id="highlight-setting" class="feature-link collapse-btn active" tabindex="0"
          v-on:click="selectSettingGroup(index)" :aria-expanded="displayedIndex == index">
          {{ $t("Settings." + (settingGroup as any)[1].label) }}
          <img src="@/assets/upward-arrow.svg" :alt="displayedIndex == index ? 'Collapse' : 'Expand'" />
        </button>
        <div class="filter-data-show" v-if="displayedIndex == index">
          <div class="show-highlight-settings">
            <div v-for="(setting, index) in Object.entries(
        (settingGroup as any)[1].settings,)" :key="index">
              <div v-if="(setting as any)[1].type == 'range'">
                <span class="feature-text relevance-score">
                  {{
                    $t(
                      "Settings." +
                      (setting as any)[1].label,
                    )
                  }}
                </span>
                <label class="slide-btn-container slide-btn-container settings-switch" :aria-label='$t("Settings." + (setting as any)[1].label)'>
                  <input type="range" min="1" max="20" v-model="(setting as any)[1].value"
                    v-on:change="updateSavedSettings()" class="slider-panel" />
                  <span>{{ (setting as any)[1].value }}</span>
                </label>
              </div>
              <div v-if="(setting as any)[1].type == 'switch'" class="settings-switch">
                <span>
                  {{
                    $t("Settings." + (setting as any)[1].label)
                  }}
                </span>
                <label class="custom-switch" :aria-label='$t("Settings." + (setting as any)[1].label)'>
                  <input type="checkbox" v-model="(setting as any)[1].value" v-on:change="updateSavedSettings()"
                    role="switch" tabindex="0" :aria-checked="(setting as any)[1].value" />
                  <span class="slider-round"></span>
                </label>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { Vue } from "vue-class-component";

export default class Settings extends Vue {
  settings = {};
  displayedIndex = -1;

  mounted() {
    chrome.runtime.sendMessage({ type: "get-settings" }, (response) => {
      if (response) {
        this.settings = response.activeSettings;
      }
    });
  }

  selectSettingGroup(index: number) {
    if (index == this.displayedIndex) {
      this.displayedIndex = -1;
    } else {
      this.displayedIndex = index;
    }
  }

  updateSavedSettings() {
    chrome.runtime.sendMessage({
      type: "set-settings",
      settings: this.settings,
    });

    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    this.$i18n.locale = (this.settings as any).hidden.settings
      .languageSelection.value
      ? "en"
      : "fr";
  }
}
</script>
<style></style>
